/*
 *	main.c
 *
 *	SLIPT[o[(pingv)
 *
 *	* Sun Aug 07 03:19:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	app_main();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
	pceLCDSetBuffer(vbuff);
	pceLCDDispStart();
	pcePadSetTrigMode(PP_MODE_SINGLE);

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* IPAhX̏lݒ肵܂B */
	ip_address[0] = 192<<24|168<<16|255<<8|  1; /* Source */
	ip_address[1] = 192<<24|168<<16|255<<8|254; /* Destination */

	/* PCrunŎsꍇUSB̂߂ɁAxď܂B */
	delay(SEC(0.1));
	slip_open(0/*MTU=l:1006oCg()*/, rxdone, NULL);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
	/* mɐؒf܂B */
	slip_close();
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	static unsigned char rep[8]; /* I[gs[gJE^ */
	//
	int x;
	int y;

	/* ʍXVB */
	pceLCDTrans();

	/* VXeB */
	yield();

	/* pbhԍXVB */
	joy = pcePadGet();

	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}

	/* O[o^C}XVB */
	now++;
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	app_main
 ****************************************************************************/

void
app_main()
{
	IPHEADER hdr;
	int len;
	int seg[4];

	sel_row = 1;
	sel_col = 3;
	for(;;) {
		schedule();

		/* SELECT{^ŏIB */
		if(joy & TRG_SELECT) {
			break;
		}

		/* START{^pingvB */
		if(joy & TRG_START) {
ENTER_CS; /*{{ipbuf[]pӂĂȂ̂ŁArxdone()Ƃ̔r䂪Kv*/
			PUT_BEBYTE(ipbuf+0, 8);		/* type = ICMP echo request */
			PUT_BEBYTE(ipbuf+1, 0);		/* code = not use */
			memcpy(ipbuf+4, "ABCD", 4);	/* ICMP data = "ABCD" */
			update_internet_checksum(ipbuf, 8, 2);
			//
			memset(&hdr, 0, sizeof hdr);
			hdr.protocol = 1; /* ICMP */
			hdr.source_ip_address = ip_address[0];
			hdr.destination_ip_address = ip_address[1];
			hdr.data = ipbuf;
			hdr.data_length = 4 + 4;	/* ICMP header + ICMP data */ 
			len = pack_ip_header(&hdr, ipbuf, sizeof ipbuf);
			if(len > 0) {
				slip_send(ipbuf, len);
			}
LEAVE_CS; /*}}ipbuf[]pӂĂȂ̂ŁArxdone()Ƃ̔r䂪Kv*/
		}

		/* IPAhXIB */
		if((joy & TRG_UP) && (sel_row > 0)) {
			sel_row--;
		}
		if((joy & TRG_DN) && (sel_row < 1)) {
			sel_row++;
		}
		if((joy & TRG_LF) && (sel_col > 0)) {
			sel_col--;
		}
		if((joy & TRG_RI) && (sel_col < 3)) {
			sel_col++;
		}

		/* IPAhXB */
		seg[0] = (ip_address[sel_row]>>24) & 255;
		seg[1] = (ip_address[sel_row]>>16) & 255;
		seg[2] = (ip_address[sel_row]>> 8) & 255;
		seg[3] = (ip_address[sel_row]>> 0) & 255;
		if(joy & TRG_A) {
			seg[sel_col] = (seg[sel_col] + 1) & 255;
		}
		if(joy & TRG_B) {
			seg[sel_col] = (seg[sel_col] - 1) & 255;
		}
		ip_address[sel_row] = (seg[0]<<24)
				    | (seg[1]<<16)
				    | (seg[2]<< 8)
				    | (seg[3]<< 0);

		/* J[\_ŃJE^XVB */
		if(joy & (PAD_A | PAD_B)) {
			blink = 0;
		} else {
			blink++;
		}

		/* ʕ\B */
		disp();
	}

}

/****************************************************************************
 *	
 ****************************************************************************/

void
rxdone()
{
	IPHEADER hdr;
	int len;

	len = slip_recv(ipbuf, sizeof ipbuf);
	len = unpack_ip_header(&hdr, ipbuf, len);
	if(len < 0) {
		return;
	}
	if(hdr.protocol != 1) { /* ICMP */
		return;
	}
	if(hdr.destination_ip_address != ip_address[0]) {
		return;
	}
	if(hdr.data_length < 4) { /* ICMP header */
		return;
	}
	if(internet_checksum(hdr.data, hdr.data_length) != 0) {
		return;
	}

	switch(hdr.data[0]) {
	case 0: /* ICMP echo reply */
		if(memcmp(hdr.data+4, "ABCD", 4) == 0) {
			ping_cnt++;
			ping_blink = SEC(0.5);
		}
		return;

	case 8: /* ICMP echo request */
		XCHG(hdr.source_ip_address, hdr.destination_ip_address);
		hdr.data[0] = 0; /* ICMP echo reply */
		update_internet_checksum(hdr.data, hdr.data_length, 2);
		len = pack_ip_header(&hdr, ipbuf, sizeof ipbuf);
		if(len < 0) {
			return;
		}
		slip_send(ipbuf, len);
		return;
	}
}

/****************************************************************************
 *	disp
 ****************************************************************************/

void
disp()
{
	int seg[4];
	UIOSTAT us;
	SLIPSTAT ss;
	int i;
	int j;
	int x;
	int y;

	uio_stat(&us);
	slip_stat(&ss);

	memset(vbuff, 0, sizeof vbuff);
	pceFontSetType(0x80);
	pceFontSetTxColor(0);
	pceFontSetBkColor(3);
	pceFontSetPos((DISP_X - 5 * 25) / 2, 0);
	/*             OPQRSTUVWXOPQ */
	pceFontPutStr("== SLIPް(pingv) ==");
	x = 4;
	y = 11;
	//
	pceFontSetTxColor(3);
	pceFontSetBkColor(-1);
	for(j = 0; j < 2; j++) {
		pceFontSetPos(x, y);
		if(j == sel_row) {
			render_rectangle_fill(&render, 0, y, DISP_X, 10, 1);
		}
		if(j == 0) {
			pceFontPrintf("MIP:");
		} else {
			pceFontPrintf("ĐIP:");
		}
		seg[0] = (ip_address[j]>>24) & 255;
		seg[1] = (ip_address[j]>>16) & 255;
		seg[2] = (ip_address[j]>> 8) & 255;
		seg[3] = (ip_address[j]>> 0) & 255;
		for(i = 0; i < 4; i++) {
			pceFontSetTxColor(3);
			pceFontSetBkColor(-1);
			if((i == sel_col) && (j == sel_row)) {
				if(blink % SEC(0.5) < SEC(0.3)) {
					pceFontSetTxColor(0);
					pceFontSetBkColor(2);
				}
			}
			pceFontPrintf("%3d", seg[i]);
			pceFontSetTxColor(3);
			pceFontSetBkColor(-1);
			if(i != 3) {
				pceFontPrintf(".");
			}
		}
		y += 10;
	}
	pceFontSetTxColor(3);
	pceFontSetBkColor(-1);
	//
	pceFontSetPos(x, y);
	if(ping_blink) {
		ping_blink--;
		i = 4 * ping_blink / SEC(0.5);
		if(i > 3) {
			i = 3;
		}
		render_rectangle_fill(&render, 0, y, DISP_X, 10, i);
		pceFontSetTxColor(3 - i);
	}
	pceFontPrintf("pingM@F%8u", ping_cnt % 100000000);
	pceFontSetTxColor(3);
	y += 9;
	//
	pceFontSetPos(x, y);
	pceFontPrintf("MoCg@F%8u", us.txlog % 100000000);
	y += 9;
	//
	pceFontSetPos(x, y);
	pceFontPrintf("MoCg@F%8u", us.rxlog % 100000000);
	y += 9;
	//
	pceFontSetPos(x, y);
	pceFontPrintf("MpPbgF%8u", ss.txlog % 100000000);
	y += 9;
	//
	pceFontSetPos(x, y);
	pceFontPrintf("MpPbgF%8u", ss.rxlog % 100000000);
	y += 9;
	//
	pceFontSetTxColor(0);
	pceFontSetBkColor(2);
	pceFontSetPos((DISP_X - 10 * 13) / 2, DISP_Y - 10);
	/*             OPQRSTUVWXOPQ */
	pceFontPutStr(" SELECT{^ŏI܂ ");
	pceLCDTrans();
}

